package com.example.switchyard.bz1138738;

import javax.xml.namespace.QName;

import org.switchyard.remote.RemoteInvoker;
import org.switchyard.remote.RemoteMessage;
import org.switchyard.remote.http.HttpInvoker;

/**
 * Test client which uses RemoteInvoker to invoke a service with an SCA binding.
 */
public final class RemoteClient {

	private static final QName SERVICE = new QName(
			"urn:com.example.switchyard:bz-1138738:1.0",
			"TestService");

	/**
	 * Private no-args constructor.
	 */
	private RemoteClient() {
	}

	/**
	 * Only execution point for this application.
	 * @param ignored not used.
	 * @throws Exception if something goes wrong.
	 */
	public static void main(final String[] ignored) throws Exception {
		// Create a new remote client invoker
		String port = System.getProperty("org.switchyard.component.sca.client.port", "8080");
		RemoteInvoker invoker = new HttpInvoker("http://localhost:" + port + "/switchyard-remote");

		// Create the request message
		RemoteMessage message = new RemoteMessage();
		message.setService(SERVICE).setOperation("test").setContent("World");

		// Invoke the service
		RemoteMessage reply = invoker.invoke(message);
		if (reply.isFault()) {
			System.out.println("ERROR");
		} else {
			System.out.println((String)reply.getContent());
		}
	}
}
